<template>
  <div ref="dialogBackground" class="dialog-background" v-if="visible" @click="bgClicked">
    <div class="dialog-window" :class="{'fullscreen': isFullscreen, 'max-size': maxSize}">
      <div class="dialog-header" v-if="showHeader" @dblclick="headerDoubleClick">
        <div class="dialog-header-left">
          <slot name="header-left" />
        </div>
        <div class="dialog-header-center">
          <h3 v-if="dialogTitle">{{dialogTitle}}</h3>
          <slot name="header-center" />
        </div>
        <div class="dialog-header-right">
          <slot name="header-right" />
          <button
            class="hideOnMobile"
            @click="isFullscreen = !isFullscreen"
            v-if="showFullscreenButton"
            :title="isFullscreen ? 'Restore' : 'Fullscreen'"
          >
            <awesome-icon v-if="isFullscreen" icon="compress" />
            <awesome-icon v-else icon="expand" />
          </button>
          <button @click="cancel" class="red" v-if="showCloseButton" title="Close">
            <awesome-icon icon="times" />
          </button>
        </div>
      </div>
      <div class="dialog-body">
        <slot />
        <div class="dialog-body-content" v-if="dialogContent" v-html="dialogContent" />
      </div>
      <div class="dialog-footer" v-if="showFooter">
        <div class="dialog-footer-left">
          <span v-if="messageText" class="dialog-message" :class="messageClass">
            <awesome-icon v-if="messageIcon" :icon="messageIcon" />
            {{messageText}}
          </span>
          <slot name="footer-left" />
        </div>
        <div class="dialog-footer-center">
          <slot name="footer-center" />
        </div>
        <div>
          <slot name="footer-right" />
          <div
            class="dialog-footer-controls"
            v-if="showFooterButtons && (openButtons == null || openButtons.length > 0)"
          >
            <button
              v-for="(button, i) in dialogButtons"
              :key="i"
              @click="click('clicked', button.text || button)"
              :class="button.class || ''"
              :disabled="button.disabled"
              :title="button.title || ''"
              v-show="button.visible != false"
            >
              <awesome-icon v-if="button.icon" :icon="button.icon" class="ma-right8" />
              {{button.text || button}}
            </button>
            <button
              ref="dialogButton"
              @click="click('accept')"
              v-if="showFooterButtons && !dialogButtons"
              :disabled="!enableFooterButtons"
              :class="buttonClass"
            >
              <awesome-icon v-if="buttonIcon" :icon="buttonIcon" class="ma-right8" />
              {{buttonText}}
            </button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
export default {
  name:"DialogControl",
  props: {
    title: { type: String, default: "" },
    content: { type: String, default: "" },
    closeOnEscape: {
      type: Boolean,
      default: true
    },
    closeOnFocusLost: {
      type: Boolean,
      default: true
    },
    closeOnButtonClick: {
      type: Boolean,
      default: true
    },
    showFooter: {
      type: Boolean,
      default: true
    },
    showHeader: {
      type: Boolean,
      default: true
    },
    showCloseButton: {
      type: Boolean,
      default: true
    },
    showFooterButtons: {
      type: Boolean,
      default: true
    },
    showFullscreenButton: {
      type: Boolean,
      default: false
    },
    enableFooterButtons: {
      type: Boolean,
      default: true
    },
    buttonText: {
      type: String,
      default: "Übernehmen"
    },
    buttonClass: {
      type: String,
      default: ""
    },
    buttonIcon: {
      type: String,
      default: ""
    },
    buttons: {
      type: Array
    },
    messageText: {
      type: String,
      default: ""
    },
    messageClass: {
      type: String,
      default: ""
    },
    messageIcon: {
      type: String,
      default: ""
    },
    maxSize: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      visible: false,
      openTitle: "",
      openContent: "",
      openButtons: null,
      isFullscreen: false,
      callback: null
    };
  },
  methods: {
    open(title = null, content = null, buttons = null, callback = null) {
      this.visible = true;
      if (title) {
        this.openTitle = title;
      }
      if (content) {
        this.openContent = content;
      }
      if (buttons) {
        this.openButtons = buttons;
      }
      if (callback) {
        this.callback = callback;
      }
      window.addEventListener("keydown", this.keydownListener);
      this.focusButton();
      this.$emit("opened");
    },
    close() {
      this.visible = false;
      window.removeEventListener("keydown", this.keydownListener);
      this.$emit("closed");
      if (this.callback) {
        this.callback();
      }
    },
    cancel() {
      this.$emit("canceled");
      this.close();
    },
    focusButton() {
      this.$nextTick(() => {
        if (this.$refs.dialogButton) {
          this.$refs.dialogButton.focus();
        }
      });
    },
    click(name, parameter = null) {
      this.$emit(name, parameter);
      if (this.callback) {
        this.callback(parameter || name);
        this.callback = undefined;
      }
      if (this.closeOnButtonClick) {
        this.close();
      }
    },
    bgClicked(e) {
      if (
        e.srcElement == this.$refs.dialogBackground &&
        this.closeOnFocusLost
      ) {
        this.cancel();
      }
    },
    headerDoubleClick() {
      if (this.showFullscreenButton) {
        this.isFullscreen = !this.isFullscreen;
      }
    },
    keydownListener(e) {
      if (e.key == "Escape" && this.closeOnEscape) {
        e.preventDefault();
        this.cancel();
      }
    }
  },
  computed: {
    dialogTitle() {
      return this.openTitle || this.title;
    },
    dialogButtons() {
      return this.openButtons || this.buttons;
    },
    dialogContent() {
      return this.openContent || this.content;
    }
  }
};
</script>

<style scoped>
</style>